package de.lmu.ifi.pms.cep.compilation;

import de.lmu.ifi.pms.java.LoggingObject;


public abstract class Compiler<SourceProgramType, DestinationProgramType> extends LoggingObject{
	
	public final Class<SourceProgramType> sourceProgramType;
	
	public final Class<DestinationProgramType> destinationProgramType;		

	public Compiler(final Class<SourceProgramType> sourceProgramType, final Class<DestinationProgramType> destinationProgramType) {
		super();
		this.sourceProgramType = sourceProgramType;
		this.destinationProgramType = destinationProgramType;
	}

	public abstract DestinationProgramType compile(SourceProgramType sourceProgram);
	
}
