package de.lmu.ifi.pms.cep.dura.compiler.antlr.utils;

import org.antlr.runtime.tree.CommonTree;

public class DuraImplicitTree extends DuraTree {
	public final DuraTree origin;
	
	public DuraImplicitTree(Object tree, DuraTree origin) {
		this((CommonTree) tree, null, origin, null);
	}
	
	public DuraImplicitTree(CommonTree tree, DuraImplicitTree parent, DuraTree origin, String filename) {
		super(tree);
		
		setChildIndex(tree.childIndex);
		setParent(parent);
		
		int n = tree.getChildCount();
		for (int i = 0; i < n; i++) {
			CommonTree child = (CommonTree) tree.getChild(i);
			DuraImplicitTree newSubTree = new DuraImplicitTree(child, this, origin, filename);
			addChild(newSubTree);
		}
		
		this.origin = origin;
	}
	
	@Override
	public String getPositionDescription() {
		return getPositionDescription(origin);
	}
	
	public int getLastLine() {
		return getLastLine(origin);
	}
	
	@Override
	public DuraImplicitTree getChild(int i) {
		if (children==null || i>=children.size()) {
			return null;
		}
		
		return (DuraImplicitTree) children.get(i);
	}
	
	@Override
	public DuraImplicitTree getParent() {
		return (DuraImplicitTree) parent;
	}
}
