package de.lmu.ifi.pms.cep.dura.compiler.durac.formula_transformations;

import de.lmu.ifi.pms.cep.dura.compiler.exceptions.DuraCExceptionWrapper;
import de.lmu.ifi.pms.cep.tsa.conditions.AtomicTerm;
import de.lmu.ifi.pms.cep.tsa.conditions.TypedAttribute;
import de.lmu.ifi.pms.cep.tsa.conditions.UntypedAttribute;
import de.lmu.ifi.pms.cep.tsa.exceptions.TSA_TypeException;
import de.lmu.ifi.pms.cep.tsa.schema.TemporalStreamSchema;
import de.lmu.ifi.pms.java.util.adaption.Adapter;

class MapTypeAttributes implements Adapter<AtomicTerm<?>, AtomicTerm<?>> {
	public final TemporalStreamSchema schema;
	
	public MapTypeAttributes(final TemporalStreamSchema schema) {
		this.schema = schema;
	}

	@Override
	public AtomicTerm<?> adapt(final AtomicTerm<?> source) {
		if (source.isTyped) {
			return source;
		} else if (source instanceof UntypedAttribute) {
			UntypedAttribute attribute = (UntypedAttribute) source;
			
			try {
				return TypedAttribute.create(attribute.name, this.schema.typeOf(attribute.name));
			} catch (TSA_TypeException e) {
				throw new DuraCExceptionWrapper(e);
			}
		} else {
			return source;
		}
	}
}