package de.lmu.ifi.pms.cep.dura.compiler.durac.token_mappings;

import java.util.HashMap;
import java.util.Map;

import de.lmu.ifi.pms.cep.dura.compiler.antlr.utils.DuraTree;

import static de.lmu.ifi.pms.cep.dura.compiler.antlr.DuraLexer.*;

public enum DuraVisibilityModifier {
	PUBLIC,
	DEFAULT,
	PRIVATE;
	
	private static final Map<String,DuraVisibilityModifier> duraNameMapping = new HashMap<String, DuraVisibilityModifier>();
	
	static {
		duraNameMapping.put("public", PUBLIC);
		duraNameMapping.put("private", PRIVATE);
	}
	
	public static DuraVisibilityModifier toVisibilityModifier(DuraTree modifiers) {
		assert modifiers.getType()==MODIFIERS;
		
		for (int i=0; i<modifiers.getChildCount(); i++) {
			String modifier = modifiers.getChild(i).getText();

			if (duraNameMapping.containsKey(modifier)) {
				return duraNameMapping.get(modifier);
			}
		}
		
		return DEFAULT;
	}
}
