package de.lmu.ifi.pms.cep.dura.compiler.durac.tsa;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.dura.compiler.durac.collections.TypeDefinitions;
import de.lmu.ifi.pms.cep.tsa.conditions.Term;
import de.lmu.ifi.pms.cep.tsa.conditions.UserTupleFunction;
import de.lmu.ifi.pms.cep.tsa.schema.CompositeType;
import de.lmu.ifi.pms.cep.tsa.schema.NamedType;


public class TimeIntervalOp extends UserTupleFunction<NamedType<CompositeType>> {
	
	public TimeIntervalOp(@Attribute(name="name")final String name, @ElementList(entry="term", inline=true, required=false, empty=false) final  java.util.ArrayList<Term<?>> arguments) {
		this(name, arguments.toArray(new Term<?>[arguments.size()]));
	}
	
	public TimeIntervalOp(final String name, final Term<?>... arguments) {
		super(name, TypeDefinitions.TIME_INTERVAL, arguments);
	}

	@Override
	public TimeIntervalOp newTerm(final Term<?>... arguments) {
		return new TimeIntervalOp(this.name, arguments);
	}
}