package de.lmu.ifi.pms.cep.event_mill.execution.dummy;

import de.lmu.ifi.pms.cep.compilation.CompilerFactory;
import de.lmu.ifi.pms.cep.event_mill.execution.program.StreamBufferStore;
import de.lmu.ifi.pms.cep.tsa.DTSA_Program;
import de.lmu.ifi.pms.cep.tsa.TSA_SyntaxPatterns;

import de.lmu.ifi.pms.development.UnimplementedMethodError;

import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArrayNavigableSet;
import de.lmu.ifi.pms.java.util.map.compatibility.TreeMap;

public class DummyStreamBufferStore extends StreamBufferStore<DummyStreamBufferStore, DummyExecutableProgram> {
	
	TreeMap<String, DummyExecutableProgram> specs = new TreeMap<String, DummyExecutableProgram>();
	TreeMap<String, DummyExecutableProgram> progs = new TreeMap<String, DummyExecutableProgram>();
	
	public DummyStreamBufferStore (){
		super(DummyStreamBufferStore.class, DummyExecutableProgram.class);
		
	}
	
	@Override
	public synchronized void initialize(){

	}
	
	@Override
	public synchronized boolean isInizialized(){
		return true;
	}
	
	@Override
	public synchronized void remove(){
	
	}
	
	@Override
	public synchronized FixedArrayNavigableSet<String> availableProgramSpecifications(){
		return new FixedArrayNavigableSet<String>(this.specs.keys());
	}
	
	@Override
	public synchronized DummyExecutableProgram getProgramSpecification(final String namespace, final String simple_name){
		String full_name = TSA_SyntaxPatterns.programFullName(namespace, simple_name);
		if(this.specs.has(full_name)){
			return this.specs.get(full_name);
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
	@Override
	public CompilerFactory<DTSA_Program, DummyExecutableProgram> DTSASpecCompiler() {
		//FIXME implement
		throw new UnimplementedMethodError();
	}
	
	@Override
	public synchronized void add(final DummyExecutableProgram program_spec){
		String full_name = program_spec.fullName;
		if(!this.specs.has(full_name)){
			this.specs.set(full_name, program_spec);
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
	@Override
	public synchronized boolean existsProgSpec(final String namespace, final String simple_name){
		String full_name = TSA_SyntaxPatterns.programFullName(namespace, simple_name);
		return this.specs.has(full_name);
	}
	
	@Override
	public synchronized void removeProgramSpec(final String namespace, final String simple_name){
		String full_name = TSA_SyntaxPatterns.programFullName(namespace, simple_name);
		this.specs.removeKey(full_name);
	}
	
	@Override
	public synchronized void clearProgramSpecs(){
		this.specs.clear();
	}
	
	@Override
	public synchronized void instanciate(final DummyExecutableProgram program_spec, final String instance, final String... schemas){
		String full_name = program_spec.fullName;
		if(!this.progs.has(full_name)){//FIXME
			this.progs.set(full_name, program_spec);
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
	@Override
	public synchronized boolean existsProgInst(final String namespace, final String simple_name, final String instance){
		String full_name = TSA_SyntaxPatterns.programInstFullName(namespace, simple_name, instance);
		return this.progs.has(full_name);
	}
	
	@Override
	public synchronized void removeProgramInst(final String namespace, final String simple_name, final String instance){
		String full_name = TSA_SyntaxPatterns.programInstFullName(namespace, simple_name, instance);
		this.progs.removeKey(full_name);
	}
	
	@Override
	public synchronized FixedArrayNavigableSet<String> availablePrograms(){
		return new FixedArrayNavigableSet<String>(this.progs.keys());
	}
	
	@Override
	public synchronized void clearProgramInsts(){
		this.progs.clear();
	}
	
	@Override
	public synchronized DummyExecutableProgram getProgram(final String namespace, final String simple_name, final String instance){
		String full_name = TSA_SyntaxPatterns.programInstFullName(namespace, simple_name, instance);
		if(this.progs.has(full_name)){
			return this.progs.get(full_name);
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
	@Override
	public void close(){
					
	}
	
	@Override
	protected void finalize() throws Throwable{
				
	}

}
