package de.lmu.ifi.pms.cep.event_mill.io;


public abstract class BufferedMessageSink<MessageType> extends MessageSink<MessageType>{
	
	public BufferedMessageSink(final Class<MessageType> type){
		super(type);
	}

	public abstract void add(final MessageType message);

	public abstract boolean nextBlock();
	
	public abstract boolean next();
	
	@Override
	public void write(final MessageType message) {
		if(!this.next()){
			this.nextBlock();
			this.next();
		}
		this.add(message);
		this.nextBlock();
	}
	
	@Override
	public void writeBlock(final MessageType[] messages) {
		for(MessageType message: messages){
			if(!this.next()){
				this.nextBlock();
				this.next();
			}
			this.add(message);
		}
		this.nextBlock();
	}
	
	@Override
	public void writeBlock(final java.util.Collection<MessageType> messages) {
		for(MessageType message: messages){
			if(!this.next()){
				this.nextBlock();
				this.next();
			}
			this.add(message);
		}
		this.nextBlock();
	}
	
}
