package de.lmu.ifi.pms.cep.event_mill.io;

import java.lang.reflect.Array;


public abstract class MessageSource<MessageType>{
	
	public final Class<MessageType> type;
	
	protected final MessageType[] emptyBlock;
	
	public MessageSource(final Class<MessageType> type){
		this.type = type;
		this.emptyBlock = this.newBlock(0);
	}
	
	@SuppressWarnings("unchecked")
	public final MessageType[] newBlock(final int size){
		return (MessageType[])Array.newInstance(this.type, size);
	}
	
	public abstract MessageType read();
	
	public MessageType[] readBlock(){
		MessageType message = this.read();
		if(message == null){
			return this.emptyBlock; 
		}
		else{
			MessageType[] block = this.newBlock(1);
			block[0] = message;
			return block;
		}
	}
	
	public void close(){
		
	}
	
	@Override
	protected void finalize() throws Throwable {
		this.close();
	}
	
}
