package de.lmu.ifi.pms.cep.event_mill.io;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import de.lmu.ifi.pms.cep.tsa.TSA_SyntaxPatterns;

public class PATTERNS {
	
	public static final String identifierRegex = ".*";
	
	public final static String streamBufferStoreIdentifierRegEx = "(.*)";
	
	public final static String programIdentifierRegEx = streamBufferStoreIdentifierRegEx + ":" + "(" + TSA_SyntaxPatterns.program_instance_full_name_RegEx + ")";
	public final static Pattern programIdentifierPattern = Pattern.compile(programIdentifierRegEx);
	
	public final static String programBusIdentifierRegEx = programIdentifierRegEx + ":" + "((?:input)|(?:output))";
	public final static Pattern programBusIdentifierPattern = Pattern.compile(programBusIdentifierRegEx);

	public static String programIdentifier(final String streamBufferStoreIdentifier, final String program_full_name){
		assert streamBufferStoreIdentifier.matches(streamBufferStoreIdentifierRegEx);
		assert program_full_name.matches(TSA_SyntaxPatterns.program_instance_full_name_RegEx);
		return streamBufferStoreIdentifier + ":" + program_full_name;
	}
	
	public static String inputBusIdentifier(final String streamBufferStoreIdentifier, final String program_full_name){
		return programIdentifier(streamBufferStoreIdentifier, program_full_name) + ":" +  "input";
	}
	
	public static String outputBusIdentifier(final String streamBufferStoreIdentifier, final String program_full_name){
		return programIdentifier(streamBufferStoreIdentifier, program_full_name) + ":" +  "output";
	}
	
	public static String[] programIdentifier(final String identifier){
		Matcher matcher = programIdentifierPattern.matcher(identifier);
		if(matcher.matches()){
			return new String[]{matcher.group(1), matcher.group(2)};
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
	public static String[] busIdentifier(final String identifier){
		Matcher matcher = programBusIdentifierPattern.matcher(identifier);
		if(matcher.matches()){
			return new String[]{matcher.group(1), matcher.group(2), matcher.group(6)};
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
}
