package de.lmu.ifi.pms.cep.event_mill.sql.creation;

import de.lmu.ifi.pms.cep.event_mill.sql.SQL_Translation;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArrayNavigableSet;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;


public class SQL_ExpressionFactorySubqueryInput extends SQL_ExpressionFactoryInput {
	
	public final SQL_ExpressionFactory subQuery;
	
	public SQL_ExpressionFactorySubqueryInput(final SQL_ExpressionFactory subQuery) {
		super();
		this.subQuery = subQuery;
	}
	
	@Override
	public FixedArrayNavigableSet<String> schema() {
		return this.subQuery.schema();
	}
	
	@Override
	public int numberOfDirectInputs(final boolean writeAlias){
		return this.subQuery.numberOfDirectInputs();
	}
	
	@Override
	public int numberOfSubqueries(final boolean writeAlias){
		return (writeAlias ? this.subQuery.numberOfSubqueries() + 1 : this.subQuery.numberOfSubqueries());
	}
	
	@Override
	protected String alias(final int directInputNumber, final int formatingLength){
		return SQL_Translation.SQL_BasicTableName(String.format("subquery%0" + Integer.toString(formatingLength) + "d", directInputNumber));
	}
	
	@Override
	public FixedArrayNavigableMap<String, String> aliasMapping(final int directInputNumber, final int formatingLength){
		return this.subQuery.aliasMapping(directInputNumber, formatingLength);
	}
	
	@Override
	public void writeTo(final StringBuilder sqlQuery, final int directInputNumber, final int subqueryNumber, final int formatingLength, final int indentDepth, final boolean writeAlias) {
		SQL_QueryBuildHelper.indentTab(sqlQuery, indentDepth);
		sqlQuery.append("(\n");
		this.subQuery.writeTo(sqlQuery, directInputNumber, (writeAlias ? subqueryNumber + 1 : subqueryNumber), formatingLength, indentDepth);
		SQL_QueryBuildHelper.indentTab(sqlQuery, indentDepth);
		sqlQuery.append(")");
		if(writeAlias){
			sqlQuery.append(" AS ");
			sqlQuery.append("\"");
			sqlQuery.append(this.alias(subqueryNumber, formatingLength));
			sqlQuery.append("\"");
		}
	}

}
