package de.lmu.ifi.pms.cep.event_mill.sql.io;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.Path;

import de.lmu.ifi.pms.cep.event_mill.configuration.SQL_ConnectionConfiguration;
import de.lmu.ifi.pms.cep.event_mill.configuration.SQL_DatabaseDriver;
import de.lmu.ifi.pms.cep.event_mill.io.EngineIO;
import de.lmu.ifi.pms.cep.event_mill.io.EngineIOProvider;
import de.lmu.ifi.pms.cep.event_mill.sql.SQL_StreamBufferStore;

public class SQL_EngineIOProvider extends EngineIOProvider<SQL_StreamBufferStore> {
	
	@Element(name="driver")
	public final SQL_DatabaseDriver driver;
	
	@Element(name="connection")
	public final SQL_ConnectionConfiguration connection;
	
	@Attribute(name="name")
	@Path("meta_schema")
	public final String meta_schema;

	public SQL_EngineIOProvider(@Attribute(name="iri") final String streamBufferStoreIdentifier
			, @Element(name="driver") final SQL_DatabaseDriver driver
			, @Element(name="connection") final SQL_ConnectionConfiguration connection
			, @Attribute(name="name")@Path("meta_schema") final String meta_schema) {
		super(SQL_StreamBufferStore.class, streamBufferStoreIdentifier);
		this.driver = driver;
		this.connection = connection;
		this.meta_schema = meta_schema;
	}

	@Override
	public EngineIO<SQL_StreamBufferStore> connectEngine(final String program_full_name){
		return new SQL_EngineIO(this.identifier, this.driver, this.connection, this.meta_schema, program_full_name);
	}

}
