package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;

public class Average<TypeClass extends AType> extends AggregationFunction<TypeClass> {

	public Average(final TypeClass type, final Term<?> argument) {
		super(AggregationFunctionID.AVG, type, argument);
	}
	
	Average(@Element(name="type") final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false) final java.util.ArrayList<Term<?>> arguments) {
		super(AggregationFunctionID.AVG, type, arguments);
	}
	
	@Override
	protected Average<TypeClass> newTerm(final Term<?> argument) {
		return new Average<TypeClass>(this.type, argument);
	}

}
