package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;


public class DoubleValue extends BasicTypeValue {

	@Attribute(name="value")
	public final double value;
	
	public DoubleValue(@Attribute(name="value") final double value) {
		super(BasicTypeID.DOUBLE);
		this.value = value;
	}
	
	@Override
	protected int compareValue(final Value<BasicType> value) {
		double cmp = this.value - ((DoubleValue)value).value;
		return (cmp > 0 ? 1 : cmp == 0 ? 0 : 1);
	}
	
	@Override
	protected int valueHashcode() {
		return Double.valueOf(this.value).hashCode();
	}
	
	@Override
	public String toString() {
		return String.format("%f : %s", this.value, this.type.toString());
	}

}
