package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;


public class FloatValue extends BasicTypeValue{

	@Attribute(name="value")
	public final float value;
	
	public FloatValue(@Attribute(name="value") final float value) {
		super(BasicTypeID.FLOAT);
		this.value = value;
	}
	
	@Override
	protected int compareValue(final Value<BasicType> value) {
		float cmp = this.value - ((FloatValue)value).value;
		return (cmp > 0 ? 1 : cmp == 0 ? 0 : 1);
	}
	
	@Override
	protected int valueHashcode() {
		return Float.valueOf(this.value).hashCode();
	}
	
	@Override
	public String toString() {
		return String.format("%f : %s", this.value, this.type.toString());
	}

}
