package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.NamedType;
import de.lmu.ifi.pms.cep.tsa.schema.NamelessType;

public class NamedTypeAttribute<TypeClass extends NamelessType> extends TypedAttribute<NamedType<TypeClass>> {	

	public NamedTypeAttribute(final String name, final NamedType<TypeClass> type) {
		super(name, type);
	}
	
	@Override
	public NamedTypeAttribute<TypeClass> rename(final String newName) {
		return new NamedTypeAttribute<TypeClass>(newName, this.type);
	}
	
	public static <TypeClass extends NamelessType> NamedTypeAttribute<TypeClass>  create(final String name, final NamedType<TypeClass> type){
		return new NamedTypeAttribute<TypeClass>(name, type);
	}

}
