package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Root;

import de.lmu.ifi.pms.cep.tsa.schema.CompositeType;
import de.lmu.ifi.pms.cep.tsa.schema.NamedType;


@Root(name="tuple")
public class NamedTypeRecord extends Record<NamedType<CompositeType>> {
	
	public NamedTypeRecord(@Element(name="type", required=false) final NamedType<CompositeType> type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		this(type, arguments.toArray(new Term<?>[arguments.size()]));
	}
	
	public NamedTypeRecord(final NamedType<CompositeType> type, final Term<?>... arguments) {
		this(type, true, arguments);
	}
	
	protected NamedTypeRecord(final NamedType<CompositeType> type, final boolean copy, final Term<?>... arguments) {
		super(type, type.type.attributes.keys(), copy, arguments);
	}
	
	@Override
	public NamedTypeRecord newTerm(final Term<?>... arguments){
		return new NamedTypeRecord(this.type, arguments);
	}

}
