package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;



public class SequenceFunction extends ClockFunction {
	
	SequenceFunction(@Attribute(name="name") final String name, @Element(name="type", required=false)final BasicType type, @ElementList(entry="term", inline=true, required=false, empty=false) final java.util.ArrayList<Term<?>> arguments) {
		super(name, type);
	}
	
	public SequenceFunction(final String name, final BasicTypeID typeID) {
		super(name, typeID.type);
	}
	
	public SequenceFunction(final String name, final BasicType type) {
		super(name, type);
	}
	
	@Override
	protected int minArity() {
		return 0;
	}
	
	@Override
	protected int maxArity() {
		return 0;
	}

	@Override
	public SequenceFunction newTerm() {
		return new SequenceFunction(this.name, this.type);
	}
	
	@Override
	public String toString() {
		return super.toString();
	}
}
