package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;


public class StringValue extends BasicTypeValue {

	@Attribute(name="value")
	public final String value;
	
	public StringValue(@Attribute(name="value") final String value) {
		super(BasicTypeID.STRING);
		this.value = value;
	}
	
	@Override
	protected int compareValue(final Value<BasicType> value) {		
		return this.value.compareTo(((StringValue)value).value);
	}
	
	@Override
	protected int valueHashcode() {
		return this.value.hashCode();
	}

	@Override
	public String toString() {
		return String.format("\"%s\"", this.value); 
	}
	
}
