package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.Type;

public abstract class TypedNamedConstant<TypeClass extends Type> extends TypedConstant<TypeClass> {
	
	public final String name;

	public TypedNamedConstant(final TypeClass type, final String name) {
		super(type);
		this.name = name;
	}
	
	public abstract TypedNamedConstant<TypeClass> rename(String newName);
	
	@Override
	protected int compareToImpl(final Term<?> o) {
		int cmp = super.compareToImpl(o);
		if(cmp == 0){
			cmp = this.name.compareTo(((TypedNamedConstant<?>) o).name);
		}
		return cmp;
	}
	
	@Override
	protected boolean equalsImpl(final Object o) {
		if(super.equalsImpl(o)){
			return this.name.equals(((TypedNamedConstant<?>) o).name);
		}
		else{
			return false;
		}
	}
	
	@Override
	public int hashCode() {
		return super.hashCode() ^ this.name.hashCode();
	}
	
	@Override
	public String toString() {
		return String.format("const %s : %s", this.name, this.type.toString());
	}

}
