package de.lmu.ifi.pms.cep.tsa.time;

import static de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID.*;

import de.lmu.ifi.pms.cep.tsa.conditions.AtomicStreamBoundFormula;
import de.lmu.ifi.pms.cep.tsa.conditions.Attribute;
import de.lmu.ifi.pms.cep.tsa.conditions.ConditionFormula;
import de.lmu.ifi.pms.cep.tsa.conditions.Variable;

import de.lmu.ifi.pms.java.util.filter.AbstractFilter;

public class AtomicStreamBoundFormulaFilter extends AbstractFilter<ConditionFormula> {
	
	public static AtomicStreamBoundFormulaFilter instance = new AtomicStreamBoundFormulaFilter();
	
	@Override
	public boolean accepts(final ConditionFormula element) {
		if(element instanceof AtomicStreamBoundFormula){
			AtomicStreamBoundFormula streamBound = (AtomicStreamBoundFormula) element;
			if(streamBound.bound.type.ID == IDENTIFIER | streamBound.bound.type.ID == TIMESTAMP){
				if(streamBound.atomicTerm.type.equals(streamBound.bound.type)){
					assert streamBound.atomicTerm instanceof Attribute<?> | streamBound.atomicTerm instanceof Variable<?>;
					return true;
				}
			}
		}
		return false;
	}
	
}