package de.lmu.ifi.pms.cep.tsa.time;

import static de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID.*;

import de.lmu.ifi.pms.cep.tsa.conditions.BasicTypeAttribute;
import de.lmu.ifi.pms.cep.tsa.conditions.ConditionFormula;
import de.lmu.ifi.pms.cep.tsa.conditions.StreamBoundConstraint;

import de.lmu.ifi.pms.java.util.filter.AbstractFilter;

public class StreamBoundConstraintFilter extends AbstractFilter<ConditionFormula> {
	
	public static StreamBoundConstraintFilter instance = new StreamBoundConstraintFilter();
	
	@Override
	public boolean accepts(final ConditionFormula element) {
		if(element instanceof StreamBoundConstraint){
			StreamBoundConstraint streamBound = (StreamBoundConstraint) element;
			if(streamBound.atomicTerm instanceof BasicTypeAttribute){
				BasicTypeAttribute attribute = (BasicTypeAttribute) streamBound.atomicTerm;
				return attribute.ID == IDENTIFIER | attribute.ID == TIMESTAMP;
			}
		}
		return false;
	}
	
}