package de.lmu.ifi.pms.cep.tsa.time.functions;

import org.simpleframework.xml.Element;

public class Max extends SimpleTimeFunction {
	
	@Element(name="arity")
	public final int arity;

	public Max(@Element(name="arity") final int arity) {
		super();
		this.arity = arity;
	}

	@Override
	long apply(final long[] arguments, final int argStart) {
		final int argEnd = argStart + this.arity;
		long max = TimeConstants.MINUS_INFINITY;
		long current;
		for(int index = argStart; index < argEnd; ++index){
			current = arguments[index];
			if(max < current){
				max = current;
			}
		}
		return max;
	}

	@Override
	public int argumentArity() {
		return this.arity;
	}

}
