package de.lmu.ifi.pms.cep.tsa.time.functions;


public abstract class SimpleTimeFunction extends TimeFunction {
	
	abstract long apply(final long[] arguments, final int argStart);
	
	@Override
	public final int resultArity() {
		return 1; 
	}

	@Override
	public final void apply(final long[] arguments, final int argStart, final long[] results, final int resultStart) {
		assert argStart >= 0;
		assert resultStart >= 0;
		assert arguments.length >= argStart + this.argumentArity();
		assert results.length >= resultStart + this.resultArity(); 
		
		results[resultStart] = this.apply(arguments, argStart);
	}

}
