package de.lmu.ifi.pms.java.lang.iteration;

import java.util.NoSuchElementException;

public class ConstantValueIterator<Type> extends AbstractFixedIterator<Type> {
	
	private final Type value;
	private int count;

	public ConstantValueIterator(final Type value, final int count) {
		super();
		this.value = value;
		this.count = count;
	}

	@Override
	public boolean hasNext() {
		return this.count > 0;
	}

	@Override
	public Type next() {
		if(this.hasNext()){
			--this.count;
			return this.value;
		}
		else{
			throw new NoSuchElementException();//TODO better Exception
		}
	}

}
