package de.lmu.ifi.pms.java.lang.iteration;

import java.util.NoSuchElementException;

import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.collection.compatibility.ArrayList;
import de.lmu.ifi.pms.java.util.collection.set.SortedSet;


public class OrderedDiffIterator<Type> extends AbstractOrderedIterator<Type, ExaminingIterator<Type>, ArrayList<ExaminingIterator<Type>>>{

	@SuppressWarnings("unchecked")
	public OrderedDiffIterator(final SortedSet<Type> set1, final SortedSet<Type> set2) {
		super(new FixedArray<SortedSet<Type>>(false, set1,set2), new Adapter<SortedSet<Type>, ExaminingIterator<Type>>(){
			@Override
			public ExaminingIterator<Type> adapt(final SortedSet<Type> source) {
				return new ExaminingIteratorWrapper<Type>(source.iterator());
			}
		}, new ArrayList<ExaminingIterator<Type>>(2));
	}
	
	@Override
	public boolean hasNext() {
		boolean haveNext = this.iterators.get(0).hasNext() && this.iterators.get(1).hasNext();
		int cmp = (haveNext ? this.compare(this.iterators.get(0).examineNext(), this.iterators.get(1).examineNext()): 0);
		while(haveNext && cmp >= 0){
			if(cmp == 0){
				this.iterators.get(0).skipNext();
			}
			this.iterators.get(1).skipNext();
			
			haveNext = this.iterators.get(0).hasNext() && this.iterators.get(1).hasNext();
			cmp = (haveNext ? this.compare(this.iterators.get(0).examineNext(), this.iterators.get(1).examineNext()): 0);
		}
		return this.iterators.get(0).hasNext();
	}

	@Override
	public Type next() {
		if(this.hasNext()){
			return this.iterators.get(0).next();
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}

}
