package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;
import java.util.NoSuchElementException;

import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.compatibility.LinkedList;
import de.lmu.ifi.pms.java.util.collection.set.SortedSet;



public class OrderedIntersectionIterator<Type> extends AbstractOrderedIterator<Type, Iterator<Type>, LinkedList<Iterator<Type>>> {
	
	private Type next = null;

	public OrderedIntersectionIterator(final Collection<? extends SortedSet<Type>> sortedSets) {
		super(sortedSets, new Adapter<SortedSet<Type>, Iterator<Type>>(){
			@Override
			public Iterator<Type> adapt(final SortedSet<Type> source) {
				return source.iterator();
			}
		}, new LinkedList<Iterator<Type>>());
	}
	
	@Override
	public boolean hasNext() {
		int i = 0;
		Type buffer = null;
		int cmp;
		if(this.next == null && !this.isEmptyIterators() && this.firstIterator().hasNext()){
			this.next = this.firstIterator().next();
			i = 1;
			this.addLastFirst();
			while(this.firstIterator().hasNext() && i < this.iteratorCount()){
				cmp = -1;
				while(cmp < 0 && this.firstIterator().hasNext()){
					buffer = this.firstIterator().next();
					cmp = this.compare(buffer, this.next);
				}
				if(cmp < 0){
					this.next = null;
					return false; // !firstIterator().hasNext()
				}
				else if(cmp > 0){
					this.next = buffer;
					i = 1;
					this.addLastFirst();
				}
				else{
					++i;
					this.addLastFirst();
				}
			}	
			if(i <  this.iteratorCount()){
				this.next = null;
				return false;
			}
			else{
				return true;
			}
		}
		else{
			return this.next != null;
		}
	}

	@Override
	public Type next() {
		if(this.hasNext()){
			final Type next = this.next;
			this.next = null;
			return next;
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}
	
	protected final Iterator<? extends Type> firstIterator(){
		return this.iterators.first();
	}
	
	protected final void addLastFirst(){
		this.iterators.addLast(this.iterators.first());
		this.iterators.removeFirst();
	}

}
