package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;

import de.lmu.ifi.pms.java.util.tupel.Pair;



public class PairIterator<Type1, Type2> extends AbstractIterator<Pair<Object,Type1, Type2>>{

	private final Iterator<Type1> iterator1;
	private final Iterator<Type2> iterator2;	
	
	public PairIterator(final Iterator<Type1> iterator1, final Iterator<Type2> iterator2) {
		super();
		this.iterator1 = iterator1;
		this.iterator2 = iterator2;
	}

	@Override
	public boolean hasNext() {
		return this.iterator1.hasNext() && this.iterator2.hasNext();
	}
	
	@Override
	public Pair<Object,Type1, Type2> next() {
		return new Pair<Object,Type1, Type2>(this.iterator1.next(), this.iterator2.next());
	}	
	
	@SuppressWarnings("deprecation")
	@Override
	public void remove() {
		this.iterator1.remove();
		this.iterator2.remove();
	}
	
}
