package de.lmu.ifi.pms.java.util.adaption;

import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.javaWrapper.FromJavaCollectionWrapper;


public class CollectionAdapterImpl<SourceType, IterationType> extends CollectionAdapter<SourceType, IterationType> {

	private final Adapter<SourceType, IterationType> adapter;
	
	public CollectionAdapterImpl(final Iterable<? extends SourceType> source, final int elementCount, final Adapter<SourceType, IterationType> adapter) {
		super(source, elementCount);
		this.adapter = adapter;
	}
	
	public CollectionAdapterImpl(final java.util.Collection<? extends SourceType> c, final Adapter<SourceType, IterationType> adapter) {
		this(new FromJavaCollectionWrapper<SourceType>(c), adapter);
	}

	public CollectionAdapterImpl(final Collection<? extends SourceType> c, final Adapter<SourceType, IterationType> adapter) {
		super(c);
		this.adapter = adapter;
	}


	@Override
	public IterationType adapt(final SourceType source) {
		return this.adapter.adapt(source);
	}
	
}
