/**
 * 
 */
package de.lmu.ifi.pms.java.util.adaption;

import java.util.Iterator;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;



public abstract class FixedIteratorAdapter<SourceType, IterationType> extends AbstractFixedIterator<IterationType> implements Adapter<SourceType, IterationType>{

	private final Iterator<? extends SourceType> sourceIterator;
	
	public FixedIteratorAdapter(final Iterator<? extends SourceType> sourceIterator) {
		super();
		this.sourceIterator = sourceIterator;
	}

	@Override
	public final boolean hasNext() {
		return this.sourceIterator.hasNext();
	}

	@Override
	public final IterationType next() {
		return this.adapt(this.sourceIterator.next());
	}
	
	@Override
	public abstract IterationType adapt(SourceType source);
			
}