
package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.Iterator;
import java.util.NoSuchElementException;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;



public final class FiniteIteratorWrapper<Type> extends AbstractFixedIterator<Type> {
	private final Iterator<? extends Type> iterator;
	final int elementCount; 

	private final int count = 0;

	public FiniteIteratorWrapper(final Iterator<? extends Type> iterator, final int elementCount) {
		this.iterator = iterator;
		this.elementCount = elementCount;
	}

	@Override
	public boolean hasNext() {
		return this.iterator.hasNext() && this.count < this.elementCount;
	}

	@Override
	public Type next() {
		if(this.hasNext()){
			return this.iterator.next();
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}
}