package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import de.lmu.ifi.pms.java.lang.iteration.FixedIterator;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedCollection;
import de.lmu.ifi.pms.java.util.collection.fixed.FixedCollection;

public class HeadTailWrapper<Type> extends AbstractFixedCollection<Type> {

	private final FixedCollection<? extends Type> collection;	
	
	private Type head = null;
	
	private FixedIterator<? extends Type> tailIterator = null;
	
	public HeadTailWrapper(final Collection<? extends Type> finalCollection) {
		this(new FixedCollectionWrapper<Type>(finalCollection));
	}
	
	public HeadTailWrapper(final FixedCollection<? extends Type> collection) {
		super();
		if(collection.size() > 1){
			this.collection = collection;
		}
		else{
			throw new IllegalArgumentException();//TODO better exception
		}
	}
	
	private void setHeadAndTail(){
		this.tailIterator = this.collection.iterator();
		this.head = this.tailIterator.next();
	}

	@SuppressWarnings("unchecked")
	@Override
	public final FixedIterator<Type> iterator() {
		if(this.tailIterator == null){
			this.setHeadAndTail();
		}
		FixedIterator<? extends Type> tailIterator = this.tailIterator;
		this.tailIterator = null;
		return (FixedIterator<Type>)tailIterator;
	}
	
	public final Type head(){
		if(this.head == null){
			this.setHeadAndTail();
		}
		Type head = this.head;
		this.head = null;
		return head;
	}

	@Override
	public final int size() {
		return this.collection.size()-1;
	}

}
