package de.lmu.ifi.pms.java.util.collection.javaWrapper;

import de.lmu.ifi.pms.java.lang.iteration.ExtendibleIterator;
import de.lmu.ifi.pms.java.lang.iteration.JavaIteratorExtendibleWrapper;
import de.lmu.ifi.pms.java.util.collection.extendible.AbstractExtendibleCollection;

public class FromJavaExtendibleCollectionWrapper<Type> extends AbstractExtendibleCollection<Type> {
	
	private final java.util.Collection<Type> javaCollection;
	
	public FromJavaExtendibleCollectionWrapper(final java.util.Collection<Type> javaCollection) {
		super();
		this.javaCollection = javaCollection;
	}

	@Override
	public boolean contains(final Object o) {
		return this.javaCollection.contains(o);
	}
	
	@Override
	public boolean containsAll(final de.lmu.ifi.pms.java.util.collection.Collection<?> c) {
		return this.javaCollection.containsAll(c.javaCollection());
	}
	
	@Override
	public boolean isEmpty() {
		return this.javaCollection.isEmpty();
	}
	
	@Override
	public java.util.AbstractCollection<Type> javaCollection() {
		if(this.javaCollection instanceof java.util.AbstractCollection){
			return (java.util.AbstractCollection<Type>) this.javaCollection;
		}
		else{
			return super.javaCollection();
		}
	}
	
	@Override
	public boolean add(final Type value) {
		return this.javaCollection.add(value);
	}
	
	@Override
	public boolean addAll(final de.lmu.ifi.pms.java.util.collection.Collection<? extends Type> c) {
		return this.javaCollection.addAll(c.javaCollection());
	}
	
	@Override
	public void clear() {
		this.javaCollection.clear();
	}
	
	@Override
	public boolean remove(final Object o) {
		return this.javaCollection.remove(o);
	}
	
	@Override
	public boolean removeAll(final de.lmu.ifi.pms.java.util.collection.Collection<?> c) {
		return this.javaCollection.removeAll(c.javaCollection());
	}
	
	@Override
	public boolean retainAll(final de.lmu.ifi.pms.java.util.collection.Collection<?> c) {
		return this.javaCollection.retainAll(c.javaCollection());
	}
	
	@Override
	public Object[] toArray() {
		return this.javaCollection.toArray();
	}
	
	@Override
	public <T> T[] toArray(final T[] a) {
		return this.javaCollection.toArray(a);
	}

	@Override
	public ExtendibleIterator<Type> iterator() {
		return new JavaIteratorExtendibleWrapper<Type>(this.javaCollection);
	}

	@Override
	public final int size() {
		return this.javaCollection.size();
	}

}
