/**
 * 
 */
package de.lmu.ifi.pms.java.util.map;

import de.lmu.ifi.pms.java.lang.iteration.Iterator;
import de.lmu.ifi.pms.java.util.collection.AbstractCollection;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.javaWrapper.ToJavaSetWrapper;
import de.lmu.ifi.pms.java.util.collection.set.Set;
import de.lmu.ifi.pms.java.util.map.javaWrapper.ToJavaMapWrapper;

/**
 * @author Simon Matthias Brodt
 *
 */
public abstract class AbstractMap<KeyType, ValueType, EntryType extends Entry<KeyType, ValueType>>
	extends AbstractCollection<EntryType>
	implements Map<KeyType, ValueType, EntryType> {

	@Override
	public abstract Set<KeyType> keys();
	
	@Deprecated
	@Override
	public final Set<KeyType> keySet() {
		return this.keys();
	}

	@Override
	public abstract EntryType entry(KeyType key);

	@Override
	public abstract ValueType get(KeyType key);
	
	@SuppressWarnings("unchecked")
	@Deprecated
	@Override
	public final boolean containsKey(final Object key) {
		return this.has((KeyType)key);
	}

	@Override
	public abstract boolean has(KeyType key);

	@Override
	public abstract Collection<ValueType> values();

	@Override
	public abstract Iterator<EntryType> iterator();

	@Override
	public abstract int size();	
	
	@Override
	public java.util.AbstractSet<EntryType> javaCollection() {
		return new ToJavaSetWrapper<EntryType>(this);
	}
	
	@Override
	public java.util.Map<KeyType, ValueType> javaMap() {
		return new ToJavaMapWrapper<KeyType, ValueType>(this);
	}
	
	@Deprecated
	@Override
	public final Set<EntryType> entrySet() {
		return this;
	}

}
