package de.lmu.ifi.pms.java.util.map.javaWrapper;

import de.lmu.ifi.pms.java.util.adaption.SetAdapter;
import de.lmu.ifi.pms.java.util.map.Map;

public class ToJavaMapWrapper<KeyType, ValueType> extends java.util.AbstractMap<KeyType, ValueType> {
	
	final Map<KeyType, ValueType, ? extends de.lmu.ifi.pms.java.util.map.Entry<KeyType,ValueType>> map;
	
	public ToJavaMapWrapper(final Map<KeyType, ValueType, ? extends de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType>> map) {
		super();
		this.map = map;
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean containsKey(final Object key) {
		return this.map.has((KeyType)key);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public ValueType get(final Object key) {
		return this.map.get((KeyType)key);
	}
	
	@Override
	public java.util.Set<KeyType> keySet() {
		return this.map.keys().javaCollection();
	}
	
	@Override
	public int size() {
		return this.map.size();
	}
	
	@Override
	public java.util.Collection<ValueType> values() {
		return this.map.values().javaCollection();
	}
	
	@Override
	public String toString() {
		return this.map.toString();
	}

	@Override
	public java.util.Set<java.util.Map.Entry<KeyType, ValueType>> entrySet() {
		return new SetAdapter<de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType>,java.util.Map.Entry<KeyType, ValueType>>(this.map) {
			@Override
			public java.util.Map.Entry<KeyType, ValueType> adapt(final de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType> source) {
				return new SimpleEntry<KeyType, ValueType>(source.key(), source.value());
			}
		}.javaCollection();
	}

}
