package de.lmu.ifi.pms.java.util.pool;

import de.lmu.ifi.pms.java.util.SynchronizedBuffer;

public abstract class PoolImpl<Type> extends SynchronizedBuffer<Type> implements Pool<Type> {
	
	public PoolImpl(final int capacity, final Class<Type> type, final Object lock) {
		super(capacity, type, lock);
	}

	public PoolImpl(final int capacity, final Class<Type> type) {
		super(capacity, type);
	}

	public PoolImpl(final int capacity, final Object lock) {
		super(capacity, lock);
	}

	public PoolImpl(final int capacity) {
		super(capacity);
	}

	@Override
	public Type getElement() {
		if(this.isEmpty()){
			return this.makeElement();
		}
		else{
			return this.first();
		}
	}

	@Override
	public abstract Type makeElement();

	@Override
	public void returnElement(final Type e) {
		 synchronized (this.lock) {
			if(this.isFull()){
				
			}
			else{
				this.addLast(e);
			}
		}
	}

	@Override
	public void setCapacity(final int capacity) {
		 super.setCapacity(capacity);
	}
	
}
