package de.lmu.ifi.pms.java.util.stream.io;

import java.io.Closeable;
import java.io.IOException;
import java.io.OutputStream;

import de.lmu.ifi.pms.java.util.tupel.Single;


public class DistributedObjectOutputStream<Type> extends ObjectOutputStream<Type, Single<Closeable,java.io.ObjectOutputStream>>{
	
	private final java.io.ObjectOutputStream outputStream;	
	
	public DistributedObjectOutputStream(final OutputStream outputStream) throws IOException{
		this(new java.io.ObjectOutputStream(outputStream));
	}
	
	public DistributedObjectOutputStream(final java.io.ObjectOutputStream outputStream){
		super();
		this.outputStream = outputStream;
	}
	
	@Override
	public Single<Closeable,java.io.ObjectOutputStream> resources() {
		return new Single<Closeable,java.io.ObjectOutputStream>(this.outputStream);
	}
	
	@Override
	public Object closeLock() {
		return this;
	}
	
	@Override
	public void writeObject(final Type object){
		try {
			this.outputStream.writeObject(object);
		} catch (final IOException e) {
			// TODO ExceptionHandling
			throw new RuntimeException(e);
		}
		this.flush();
	}
	
	@Override
	public void flush(){
		try {
			this.outputStream.flush();
		} catch (final IOException e) {
			// TODO ExceptionHandling
			throw new RuntimeException(e);
		}
	}
	
}
