package de.lmu.ifi.pms.java.util.stream.io;

import java.io.Closeable;

import de.lmu.ifi.pms.java.util.tupel.Single;


public class LocalObjectOutputStream<Type> extends ObjectOutputStream<Type,Single<Closeable,BlockingPipe<Type>>> {
	
	private final BlockingPipe<Type> pipe;
	
	public LocalObjectOutputStream(final BlockingPipe<Type> pipe) {
		super();
		this.pipe = pipe;
	}
	@Override
	public Object closeLock() {
		return this.pipe;
	}
	
	@Override
	public Single<Closeable,BlockingPipe<Type>> resources() {
		return new Single<Closeable,BlockingPipe<Type>>(this.pipe);
	}
	
	@Override
	public void writeObject(final Type object){
		this.pipe.writeNext(object);
	}
	
	@Override
	public void flush(){
		//unn�tig
	}

}
