package de.lmu.ifi.pms.java.util.tupel;

public class Quadrupel<Type, Type0 extends Type, Type1 extends Type, Type2 extends Type, Type3 extends Type> extends Tripple<Type, Type0, Type1, Type2> {

	private Type3 comp3;
	
	public Quadrupel(final Type0 comp0, final Type1 comp1, final Type2 comp2, final Type3 comp3) {
		super(comp0, comp1, comp2);
		this.comp3 = comp3;
	}
	
	public final Type3 comp3(){
		return this.comp3;
	}
	
	public final void setComp3(final Type3 value){
		this.comp3 = value;
	}
	
	@Override
	public int componentCount() {
		return 4;
	}
	
	@Override
	public Type getComp(final int i) {
		if(i == 3){
			return this.comp3;
		}
		else{
			return super.getComp(i);
		}
	}
	
	@Override
	public Quadrupel<Type, Type0, Type1, Type2, Type3> clone() {
		return new Quadrupel<Type, Type0, Type1, Type2, Type3>(this.comp0(), this.comp1(), this.comp2(), this.comp3());
	}

}
