package de.lmu.ifi.pms.cep.unitTests.time.constraints.tests;

import static org.junit.Assert.assertTrue;

import org.junit.Test;

import de.lmu.ifi.pms.cep.tsa.time.constraints.ConjunctiveTemporalRelationFormula;
import de.lmu.ifi.pms.cep.tsa.time.constraints.DisjunctiveTemporalRelationFormula;
import de.lmu.ifi.pms.cep.tsa.time.constraints.SimpleTemporalFormula;
import de.lmu.ifi.pms.cep.tsa.time.constraints.TemporalRelationFormula;
import de.lmu.ifi.pms.cep.tsa.time.constraints.enums.BinaryComparisonOperator;
import de.lmu.ifi.pms.java.util.collection.AbstractCollection;


public class TestDNFConversionTest {
	@Test
	public void testTemporalConjunctionDNF(){
		TemporalRelationFormula stf1 = new SimpleTemporalFormula("w", BinaryComparisonOperator.LESS,"v",5);
		TemporalRelationFormula stf2 = new SimpleTemporalFormula("x", BinaryComparisonOperator.LESS,"y",10);
		TemporalRelationFormula stf3 = new SimpleTemporalFormula("z", BinaryComparisonOperator.LESS,"t",11);
		TemporalRelationFormula stf4 = new SimpleTemporalFormula("m", BinaryComparisonOperator.LESS,"n",11);
		TemporalRelationFormula stf5 = new SimpleTemporalFormula("a", BinaryComparisonOperator.LESS,"b",11);
		TemporalRelationFormula stf6 = new SimpleTemporalFormula("c", BinaryComparisonOperator.LESS,"d",11);
		TemporalRelationFormula disj = new DisjunctiveTemporalRelationFormula(stf1,stf2);
		TemporalRelationFormula disj2 = new DisjunctiveTemporalRelationFormula(stf3,stf4);
		TemporalRelationFormula disj3 = new DisjunctiveTemporalRelationFormula(stf5,stf6);
		TemporalRelationFormula conj = new ConjunctiveTemporalRelationFormula(disj,disj2,disj3);
		AbstractCollection<ConjunctiveTemporalRelationFormula> dnf = conj.simpleForm().tempDNFiteration();
		int count=0;
		for(ConjunctiveTemporalRelationFormula tfa: dnf){
			System.out.println(tfa);
			count++;
		}
		assertTrue(count==8);
	}
}
